#include <godot_cpp/godot.hpp>
#include <godot_cpp/core/class_db.hpp>

#include "RecastNavMesh.hpp"

void register_gameplay_types(godot::ModuleInitializationLevel p_level) {
  if (p_level != godot::ModuleInitializationLevel::MODULE_INITIALIZATION_LEVEL_SCENE) {
	return;
  }

  godot::ClassDB::register_class<godot::RecastNavMesh>();
}

void unregister_gameplay_types(godot::ModuleInitializationLevel p_level) {
  // DO NOTHING
}

extern "C" {

GDExtensionBool GDE_EXPORT recastnavigation_library_init(GDExtensionInterfaceGetProcAddress p_get_proc_address, GDExtensionClassLibraryPtr p_library, GDExtensionInitialization *r_initialization) {
	godot::GDExtensionBinding::InitObject init_obj(p_get_proc_address, p_library, r_initialization);
	init_obj.register_initializer(register_gameplay_types);
	init_obj.register_terminator(unregister_gameplay_types);
	init_obj.set_minimum_library_initialization_level(godot::MODULE_INITIALIZATION_LEVEL_SCENE);

	return init_obj.init();
}

}

